com.io7m.r2.filters

## Class R2FilterSSAOParameters.Builder

- java.lang.Object
- - com.io7m.r2.filters.R2FilterSSAOParameters.Builder

- Enclosing class:
    R2FilterSSAOParameters

      public static final class R2FilterSSAOParameters.Builder
      extends Object

  Builds instances of type `R2FilterSSAOParameters`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `R2FilterSSAOParameters` | `build()` Builds a new `R2FilterSSAOParameters`.
    `R2FilterSSAOParameters.Builder` | `from(R2FilterSSAOParametersType instance)` Fill a builder with attribute values from the provided `R2FilterSSAOParametersType` instance.
    `R2FilterSSAOParameters.Builder` | `setExponent(float exponent)` Initializes the value for the `exponent` attribute.
    `R2FilterSSAOParameters.Builder` | `setGeometryBuffer(R2GeometryBufferUsableType geometryBuffer)` Initializes the value for the `geometryBuffer` attribute.
    `R2FilterSSAOParameters.Builder` | `setKernel(R2SSAOKernelType kernel)` Initializes the value for the `kernel` attribute.
    `R2FilterSSAOParameters.Builder` | `setNoiseTexture(R2Texture2DUsableType noiseTexture)` Initializes the value for the `noiseTexture` attribute.
    `R2FilterSSAOParameters.Builder` | `setOutputBuffer(R2AmbientOcclusionBufferUsableType outputBuffer)` Initializes the value for the `outputBuffer` attribute.
    `R2FilterSSAOParameters.Builder` | `setSampleRadius(float sampleRadius)` Initializes the value for the `sampleRadius` attribute.
    `R2FilterSSAOParameters.Builder` | `setSceneObserverValues(R2MatricesObserverValuesType sceneObserverValues)` Initializes the value for the `sceneObserverValues` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final R2FilterSSAOParameters.Builder from(R2FilterSSAOParametersType instance)

      Fill a builder with attribute values from the provided `R2FilterSSAOParametersType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setExponent

          public final R2FilterSSAOParameters.Builder setExponent(float exponent)

      Initializes the value for the `exponent` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `exponent`.

      Parameters:
        `exponent` - The value for exponent
      Returns:
        `this` builder for use in a chained invocation

    - #### setNoiseTexture

          public final R2FilterSSAOParameters.Builder setNoiseTexture(R2Texture2DUsableType noiseTexture)

      Initializes the value for the `noiseTexture` attribute.
      Parameters:
        `noiseTexture` - The value for noiseTexture
      Returns:
        `this` builder for use in a chained invocation

    - #### setKernel

          public final R2FilterSSAOParameters.Builder setKernel(R2SSAOKernelType kernel)

      Initializes the value for the `kernel` attribute.
      Parameters:
        `kernel` - The value for kernel
      Returns:
        `this` builder for use in a chained invocation

    - #### setSampleRadius

          public final R2FilterSSAOParameters.Builder setSampleRadius(float sampleRadius)

      Initializes the value for the `sampleRadius` attribute.

      If not set, this attribute will have a default value as returned by the initializer of `sampleRadius`.

      Parameters:
        `sampleRadius` - The value for sampleRadius
      Returns:
        `this` builder for use in a chained invocation

    - #### setGeometryBuffer

          public final R2FilterSSAOParameters.Builder setGeometryBuffer(R2GeometryBufferUsableType geometryBuffer)

      Initializes the value for the `geometryBuffer` attribute.
      Parameters:
        `geometryBuffer` - The value for geometryBuffer
      Returns:
        `this` builder for use in a chained invocation

    - #### setOutputBuffer

          public final R2FilterSSAOParameters.Builder setOutputBuffer(R2AmbientOcclusionBufferUsableType outputBuffer)

      Initializes the value for the `outputBuffer` attribute.
      Parameters:
        `outputBuffer` - The value for outputBuffer
      Returns:
        `this` builder for use in a chained invocation

    - #### setSceneObserverValues

          public final R2FilterSSAOParameters.Builder setSceneObserverValues(R2MatricesObserverValuesType sceneObserverValues)

      Initializes the value for the `sceneObserverValues` attribute.
      Parameters:
        `sceneObserverValues` - The value for sceneObserverValues
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public R2FilterSSAOParameters build()

      Builds a new `R2FilterSSAOParameters`.
      Returns:
        An immutable instance of R2FilterSSAOParameters
      Throws:
        `IllegalStateException` - if any required attributes are missing

Copyright © 2017 <code@io7m.com> http://io7m.com